#! /usr/bin/perl 
use Tk;
use Tk::Dialog;
use Tk::DialogBox;

$main = MainWindow->new(-title=>'Concatnation de fichier :');

$frame1 = $main->Frame()->pack();

$frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
$frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);


$frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
$frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);

$frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
$frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);


$frame2 = $main->Frame()->pack();
$frame3 = $main->Frame()->pack();

$libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);

$defil = $frameD2-> Scrollbar(-orient => "horizontal");
$montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil->pack(-fill => 'x',
	     -expand => 1);
$defil->configure(-command => [$montantF => 'xview']);

$libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);


$defil2 = $frameD3-> Scrollbar(-orient => "horizontal");

$montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil2->pack(-fill => 'x',
	     -expand => 1);
$defil2->configure(-command => [$montantE => 'xview']);

$raz = $frame2->Button(-text=>'RAZ', -command=>\&vider)->pack(-side=>'left', -padx=>20, -pady=>5);
$calcul = $frame2->Button(-text=>'Concatnation', -command=>\&loadconcat)->pack(-side=>'right', -padx=>20, -pady=>5);
$fin = $frame3->Button(-text=>'Exit', -command=>sub {exit})->pack(-pady=>5);
MainLoop;

sub loadconcat
{
	$chemin=$montantF->get();
	$cheminout=$montantE->get();
	if ($chemin ne "") {
	    if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	    if (!opendir(DIR, $chemin)) {
		&mkPrintErreur("ERREUR : can't open $chemin: $!\n");
		return;
	    }  
	    if ($cheminout eq "") {
		$cheminout = $chemin."result-concatenation.txt";
	    }
	    else {
		if (!opendir(DIR2, $cheminout)) {
		    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		    return;
		} 
		if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
		$cheminout = $cheminout."result-concatenation.txt";
	    }
	    my @files = readdir(DIR);
	    closedir(DIR);

	    if (!open(TRACE, ">>$cheminout")) {
		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en sortie $cheminout  \n");
		    return;
		}	
	    $filecount = 0;
	    foreach my $file (@files) {
		my $filecount++;
		next if $file =~ /^\.\.?$/;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		if (-f $file) {
		        if (!open(FILE, $file)) {
			    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en lecture : $file \n");
			    return;
			}	
			print TRACE "\n<FICHIER=\"$file\">\n";
			while (<FILE>) {
			    print TRACE $_;
			}
			close (FILE);
		    }
	    }
	    close (TRACE);
	    &mkPrintMsgInfo("Concatnation termine dans : $cheminout \n");
	}
	else
	{
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
	}




}

sub vider
{
	$montantF->delete(0, 'end');
	$montantE->delete(0, 'end');
}

sub  mkPrintErreur {
   my $msg = shift;
   $main->Dialog(
		 -title => "ERROR !",
		 -text  => $msg
		 )->Show();
}

sub  mkPrintMsgInfo {
    my $msg = shift;
    $main->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}

